precision mediump float;

varying highp vec2 textureCoordinate;

 uniform sampler2D inputImageTexture;
 uniform sampler2D inkMap;
 uniform sampler2D inputImageTexture2; //map
 uniform sampler2D inputImageTexture3; //vigMap
 
 void main()
 {
     
     vec3 texel = texture2D(inputImageTexture, textureCoordinate).rgb;
     
     texel = vec3(dot(vec3(0.3, 0.6, 0.1), texel));
     
     texel.r = texture2D(inkMap, vec2(texel.r, .16666)).r;
     texel.g = texture2D(inkMap, vec2(texel.g, .5)).g;
     texel.b = texture2D(inkMap, vec2(texel.b, .83333)).b;
     
     
     
     //below is vintage
     vec2 tc = (2.0 * textureCoordinate) - 1.0;
     float d = smoothstep(0.0, 1.0, dot(tc, tc)/2.0);
     vec2 lookup = vec2(d, texel.r);
     texel.r = texture2D(inputImageTexture3, lookup).r - 0.23 * d;
     lookup.y = texel.g;
     texel.g = texture2D(inputImageTexture3, lookup).g - 0.23 * d;
     lookup.y = texel.b;
     texel.b = texture2D(inputImageTexture3, lookup).b - 0.23 * d;
     
     vec2 red = vec2(texel.r, 0.16666);
     vec2 green = vec2(texel.g, 0.5);
     vec2 blue = vec2(texel.b, .83333);
     texel.r = texture2D(inputImageTexture2, red).r;
     texel.g = texture2D(inputImageTexture2, green).g;
     texel.b = texture2D(inputImageTexture2, blue).b;
     
     gl_FragColor = vec4(texel , 1.0);
 }