precision mediump float;

varying highp vec2 textureCoordinate;

uniform sampler2D inputImageTexture;
uniform float centerX;
uniform float centerY;
uniform float radius;
uniform int xMutiplier;
uniform int yMutiplier;

const float FadeLength = 0.23;

highp vec2 blurCoordinates[9];

void main() {
	 
	highp vec2 singleStepOffset = vec2(0.002 * float(xMutiplier), 0.002 * float(yMutiplier));
	
	float xOff = textureCoordinate.x - centerX;
	float yOff = textureCoordinate.y - (1.0 - centerY);
	float off = sqrt(xOff * xOff + yOff * yOff);
	
    float blurRate = smoothstep(radius, radius + FadeLength, off);
   
//	if(blurRate <= 0.0){
//		 gl_FragColor = texture2D(inputImageTexture, textureCoordinate);
//	}else{
//		int multiplier = 0;
//	 	highp vec2 blurStep;
//	 	for (int i = 0; i < GAUSSIAN_SAMPLES; i++) {
//	 		multiplier = (i - ((GAUSSIAN_SAMPLES - 1) / 2));
//	        blurStep = float(multiplier) * singleStepOffset * blurRate;
//	 		blurCoordinates[i] = textureCoordinate.xy + blurStep;
//	 	}
//		Nexus 4 don't support this for loop
//		Defy gpu don't support complex vec2 plus and condition block texture2D
//	}

	highp vec2 blurStep;
	
	blurStep = (-4.0) * singleStepOffset * blurRate;
 	blurCoordinates[0] = textureCoordinate.xy + blurStep;
	blurStep = (-3.0) * singleStepOffset * blurRate;
 	blurCoordinates[1] = textureCoordinate.xy + blurStep;
	blurStep = (-2.0) * singleStepOffset * blurRate;
 	blurCoordinates[2] = textureCoordinate.xy + blurStep;
	blurStep = (-1.0) * singleStepOffset * blurRate;
 	blurCoordinates[3] = textureCoordinate.xy + blurStep;

 	blurCoordinates[4] = textureCoordinate.xy;
 	blurStep = (1.0) * singleStepOffset * blurRate;
 	blurCoordinates[5] = textureCoordinate.xy + blurStep;
	blurStep = (2.0) * singleStepOffset * blurRate;
 	blurCoordinates[6] = textureCoordinate.xy + blurStep;
	blurStep = (3.0) * singleStepOffset * blurRate;
 	blurCoordinates[7] = textureCoordinate.xy + blurStep;
	blurStep = (4.0) * singleStepOffset * blurRate;
 	blurCoordinates[8] = textureCoordinate.xy + blurStep;
 	
    gl_FragColor = texture2D(inputImageTexture, blurCoordinates[0]) * 0.05;
    gl_FragColor += texture2D(inputImageTexture, blurCoordinates[1]) * 0.09;
    gl_FragColor += texture2D(inputImageTexture, blurCoordinates[2]) * 0.12;
    gl_FragColor += texture2D(inputImageTexture, blurCoordinates[3]) * 0.15;
    gl_FragColor += texture2D(inputImageTexture, blurCoordinates[4]) * 0.18;
    gl_FragColor += texture2D(inputImageTexture, blurCoordinates[5]) * 0.15;
    gl_FragColor += texture2D(inputImageTexture, blurCoordinates[6]) * 0.12;
    gl_FragColor += texture2D(inputImageTexture, blurCoordinates[7]) * 0.09;
    gl_FragColor += texture2D(inputImageTexture, blurCoordinates[8]) * 0.05;
}