precision mediump float;

varying highp vec2 textureCoordinate;

 uniform sampler2D inputImageTexture;
 uniform sampler2D inputImageTexture2; //blowout;
 uniform sampler2D inputImageTexture3; //overlay;
 uniform sampler2D inputImageTexture4; //map
 
 uniform sampler2D smoke; //smoke;
 uniform sampler2D softlight; //softlight;
 
 void main()
 {
     vec2 look;
     look.x = textureCoordinate.x;
     look.y = 1.0 - textureCoordinate.y;
     
     vec4 texel = texture2D(inputImageTexture, textureCoordinate);
     vec3 bbTexel = texture2D(inputImageTexture2, look).rgb;
     vec3 smokeTexel = texture2D(smoke, look).rgb;
     
     texel.r = texture2D(inputImageTexture3, vec2(bbTexel.r, texel.r)).r;
     texel.g = texture2D(inputImageTexture3, vec2(bbTexel.g, texel.g)).g;
     texel.b = texture2D(inputImageTexture3, vec2(bbTexel.b, texel.b)).b;
     
     texel.r = texture2D(softlight, vec2(smokeTexel.r, texel.r)).r;
     texel.g = texture2D(softlight, vec2(smokeTexel.g, texel.g)).g;
     texel.b = texture2D(softlight, vec2(smokeTexel.b, texel.b)).b;
     
     vec4 mapped;
     mapped.r = texture2D(inputImageTexture4, vec2(texel.r, .5)).r;
     mapped.g = texture2D(inputImageTexture4, vec2(texel.g, .5)).g;
     mapped.b = texture2D(inputImageTexture4, vec2(texel.b, .5)).b;
     mapped.a = 1.0;
     
     gl_FragColor = mapped;
 }