 precision lowp float;
 
 varying highp vec2 textureCoordinate;
 
 uniform sampler2D inputImageTexture;
 uniform sampler2D inputImageTexture2; //map
 uniform sampler2D inputImageTexture3; //vigMap
 
 void main()
 {
     
     vec3 texel = texture2D(inputImageTexture, textureCoordinate).rgb;
     
     texel = vec3(
                  texture2D(inputImageTexture2, vec2(texel.r, .16666)).r,
                  texture2D(inputImageTexture2, vec2(texel.g, .5)).g,
                  texture2D(inputImageTexture2, vec2(texel.b, .83333)).b);
     
     vec2 tc = (2.0 * textureCoordinate) - 1.0;
     float d = smoothstep(0.0, 1.0, dot(tc, tc)/2.0);
     vec2 lookup = vec2(d, texel.r);
     texel.r = texture2D(inputImageTexture3, lookup).r - 0.23 * d;
     lookup.y = texel.g;
     texel.g = texture2D(inputImageTexture3, lookup).g - 0.23 * d;
     lookup.y = texel.b;
     texel.b	= texture2D(inputImageTexture3, lookup).b - 0.23 * d;
     
     gl_FragColor = vec4(texel, 1.0);
 }